unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.Math;

var
  LDBL_EPSILON: extended;


//==================================================================================================
// P튮Sȉ~ϕ
function Complete_Elliptic_Integral_First_Kind(parameter: extended): extended;
var
  a, g, a_old, g_old: extended;
begin
  if parameter = 0 then begin
    result := PI / 2;
    exit;
  end;
  if parameter = 1 then begin
    result := infinity;
    exit;;
  end;
  a := 1;
  g := sqrt(1.0 - parameter);
  while true do begin
    g_old := g;
    a_old := a;
    a := 1 / 2 * (g_old + a_old);
    g := sqrt(g_old * a_old);
    if abs(a_old - g_old) <= a_old * LDBL_EPSILON then break;
  end;
  result := PI / 2 / g;
end;

// Q튮Sȉ~ϕ
function Complete_Elliptic_Integral_Second_Kind(parameter: extended): extended;
var
  a, g, a_old, g_old: extended;
  two_n: extended;
  Ek: extended;
begin
  if parameter = 0 then begin
    result :=  PI / 2;
    exit;
  end;
  if parameter = 1 then begin
    result := 1;
    exit;
  end;
  a := 1;
  g := sqrt(1 - parameter);
  two_n := 1;
  Ek := 2 - parameter;
  while true do begin
    g_old := g;
    a_old := a;
    a := (g_old + a_old) / 2;
    g := a_old * g_old;
    two_n := two_n + two_n;
    Ek := Ek - two_n * (a * a - g);
    if abs(a_old - g_old) <= (a_old * LDBL_EPSILON) then break;
    g := sqrt(g);
  end;
  result := (PI / 4 / a) * Ek;
end;

//==================================================================================================
// PAQ탉fϊ
procedure Landen_Transform(phi, parameter: extended; var F, Fk, E, Ek: extended);
var
  two_n: extended;
  a, g, a_old, g_old: extended;
  tan_2n_phi, sum, integral: extended;
begin
  two_n := 1.0;
  a := 1.0;
  g := sqrt(1.0 - parameter);
  sum := 2.0 * (2.0 - parameter);
  integral := 0.0;
  repeat
    tan_2n_phi := tan(two_n * phi);
    sum := sum - two_n * (a - g) * (a - g);
    two_n := two_n + two_n;
    phi := phi - arctan((a - g) * tan_2n_phi / (a + g * tan_2n_phi * tan_2n_phi)) / two_n;
    integral := integral + (a - g) * sin(two_n * phi);
    g_old := g;
    a_old := a;
    a := (g_old + a_old) / 2;
    g := sqrt(g_old * a_old);
  until (abs(a_old - g_old) <= (a_old * LDBL_EPSILON));
  F := phi / g;
  Fk := PI / 2 / g;
  E :=  integral / 2 + sum * phi / g / 4;
  Ek := PI / 8 / a * sum;
end;

// QsSȉ~ϕ
procedure Elliptic_Integral_Second_Kind(phi, m: extended; var E, Ek: extended);
var
  F, Fk: extended;
  n: integer;
begin
  if m = 1 then begin
    if (abs(phi) <= PI / 2) then begin
      E := sin(phi);
      exit;
    end;
    n := trunc((abs(phi) + PI / 2) / PI);
    E := n + n + sin(abs(phi) - n * PI);
    if phi < 0 then E := - E;
    exit;
  end;
  n := trunc((phi + PI / 2) / PI );
  phi := phi - n * PI;
  n := n + n;
  Landen_Transform(abs(phi), m, F, Fk, E, Ek);
  E := sign(phi) * E  + n * Ek;
end;

// PsSȉ~ϕ
procedure Elliptic_Integral_First_Kind(phi, m: extended; var F, K: extended);
var
  E, Ek: extended;
  n : integer;
begin
  if  m = 1.0 then begin
    if abs(phi) >= PI / 2 then begin
      F := infinity;
      if phi < 0 then F := -F;
      exit;
    end;
    Ek := tan(Phi);
    F := sign(Phi) * ln(abs(Ek) + sqrt(1.0 + Ek * Ek));
    exit;
  end;
  n := trunc((phi + PI / 2) / PI);
  phi := phi - n * PI;
  n := n + n;
  Landen_Transform(abs(phi), m, F, K, E, Ek);
  F := sign(phi) * F + n * K;
end;

//==================================================================================================
procedure TForm1.BitBtn1Click(Sender: TObject);
var
  F, K, E, Ek: extended;
  kin, m : extended;
  deg, phi: extended;
  ch: integer;
begin
  val(labelededit1.Text, kin, ch);
  if ch <> 0 then begin
    application.MessageBox('Sk̒lɊԈႢ܂B','',0);
    exit;
  end;
  if (kin < 0) or (kin > 1) then begin
    application.MessageBox('Sk̒l͈͊OłB','',0);
    exit;
  end;
  val(labelededit2.Text, deg, ch);
  if ch <> 0 then begin
    application.MessageBox('ϕ͈̔̓̒lɊԈႢ܂B','',0);
    exit;
  end;
  memo1.Clear;
  m := kin * kin;                         // k^2
  phi := deg / 180 * pi;
  Elliptic_Integral_First_Kind(phi, m, F, K);
  Memo1.Lines.Append('sSP@@' + floatTostr(F));
  Elliptic_Integral_Second_Kind(phi, m, E, Ek);
  Memo1.Lines.Append('sSQ@@' + floatTostr(E));
  K := Complete_Elliptic_Integral_First_Kind(m);
  Memo1.Lines.Append('SP@@@ ' + floatTostr(K));
  EK := Complete_Elliptic_Integral_Second_Kind(m);
  Memo1.Lines.Append('SQ@@@ ' + floatTostr(EK));
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  one, tmp: extended;
begin
  one := 1;
  LDBL_EPSILON := one;
  repeat
    LDBL_EPSILON := LDBL_EPSILON / 2;
    tmp := LDBL_EPSILON + one;
  until tmp = one;
  LDBL_EPSILON := LDBL_EPSILON * 2;
  memo1.Clear;
  memo1.Lines.Append('PAQȉ~ϕ');
end;

end.
